namespace noise_shaper {
// generated from file '../src/faust/noise_shaper.dsp'

FAUSTFLOAT 	fslider0;
double 	fConst0;
double 	fConst1;
double 	fRec0[2];
double 	fRec1[2];
double 	fRec2[2];
double 	fRec3[2];
double 	fRec4[2];
int	fSamplingFreq;

void init(int samplingFreq)
{
	fSamplingFreq = samplingFreq;
	fConst0 = exp((0 - (2e+02 / fSamplingFreq)));
	fConst1 = exp((0 - (0.1 / fSamplingFreq)));
	for (int i=0; i<2; i++) fRec0[i] = 0;
	for (int i=0; i<2; i++) fRec1[i] = 0;
	for (int i=0; i<2; i++) fRec2[i] = 0;
	for (int i=0; i<2; i++) fRec3[i] = 0;
	for (int i=0; i<2; i++) fRec4[i] = 0;
}

void compute(int count, float *input0, float *output0)
{
	double 	fSlow0 = fslider0;
	double 	fSlow1 = (5 * fSlow0);
	for (int i=0; i<count; i++) {
		double fTemp0 = (double)input0[i];
		double fTemp1 = max(1, fabs(fTemp0));
		double fTemp2 = ((fConst0 * (fRec0[1] < fTemp1)) + (fConst1 * (fRec0[1] >= fTemp1)));
		fRec0[0] = ((fRec0[1] * fTemp2) + (fTemp1 * (1 - fTemp2)));
		double fTemp3 = ((fConst0 * (fRec1[1] < fTemp1)) + (fConst1 * (fRec1[1] >= fTemp1)));
		fRec1[0] = ((fRec1[1] * fTemp3) + (fTemp1 * (1 - fTemp3)));
		double fTemp4 = ((fConst0 * (fRec2[1] < fTemp1)) + (fConst1 * (fRec2[1] >= fTemp1)));
		fRec2[0] = ((fRec2[1] * fTemp4) + (fTemp1 * (1 - fTemp4)));
		double fTemp5 = ((fConst0 * (fRec3[1] < fTemp1)) + (fConst1 * (fRec3[1] >= fTemp1)));
		fRec3[0] = ((fRec3[1] * fTemp5) + (fTemp1 * (1 - fTemp5)));
		double fTemp6 = ((fConst0 * (fRec4[1] < fTemp1)) + (fConst1 * (fRec4[1] >= fTemp1)));
		fRec4[0] = ((fRec4[1] * fTemp6) + (fTemp1 * (1 - fTemp6)));
		output0[i] = (FAUSTFLOAT)(fTemp0 * pow(10,(0.05 * (fSlow0 + ((max(0, (fSlow1 + (20 * log10(fRec0[0])))) * (min(1, max(0, (0.09522902580706599 * max(0, (fSlow1 + (20 * log10(fRec1[0]))))))) - (1.5 * min(1, max(0, (0.09522902580706599 * max(0, (fSlow1 + (20 * log10(fRec2[0])))))))))) / ((1 + (1.5 * min(1, max(0, (0.09522902580706599 * max(0, (fSlow1 + (20 * log10(fRec3[0]))))))))) - min(1, max(0, (0.09522902580706599 * max(0, (fSlow1 + (20 * log10(fRec4[0])))))))))))));
		// post processing
		fRec4[1] = fRec4[0];
		fRec3[1] = fRec3[0];
		fRec2[1] = fRec2[0];
		fRec1[1] = fRec1[0];
		fRec0[1] = fRec0[0];
	}
}

static struct RegisterParams { RegisterParams(); } RegisterParams;
RegisterParams::RegisterParams()
{
	registerVar("shaper.sharper","sharper","S","",&fslider0, 1.0, 1.0, 1e+01, 1.0);
	registerInit("shaper", init);
}

} // end namespace noise_shaper
