namespace phaser {
// generated from file '../src/faust/phaser.dsp'

FAUSTFLOAT 	fslider0;
int 	iVec0[2];
FAUSTFLOAT 	fcheckbox0;
FAUSTFLOAT 	fslider1;
double 	fConst0;
FAUSTFLOAT 	fslider2;
FAUSTFLOAT 	fslider3;
FAUSTFLOAT 	fslider4;
FAUSTFLOAT 	fslider5;
double 	fConst1;
FAUSTFLOAT 	fslider6;
double 	fRec2[2];
double 	fRec3[2];
FAUSTFLOAT 	fslider7;
double 	fRec6[3];
double 	fRec5[3];
double 	fRec4[3];
double 	fRec1[3];
double 	fRec0[2];
FAUSTFLOAT 	fcheckbox1;
double 	fRec11[3];
double 	fRec10[3];
double 	fRec9[3];
double 	fRec8[3];
double 	fRec7[2];
int	fSamplingFreq;

void init(int samplingFreq)
{
	fSamplingFreq = samplingFreq;
	for (int i=0; i<2; i++) iVec0[i] = 0;
	fConst0 = (1.0 / fSamplingFreq);
	fConst1 = (6.283185307179586 / fSamplingFreq);
	for (int i=0; i<2; i++) fRec2[i] = 0;
	for (int i=0; i<2; i++) fRec3[i] = 0;
	for (int i=0; i<3; i++) fRec6[i] = 0;
	for (int i=0; i<3; i++) fRec5[i] = 0;
	for (int i=0; i<3; i++) fRec4[i] = 0;
	for (int i=0; i<3; i++) fRec1[i] = 0;
	for (int i=0; i<2; i++) fRec0[i] = 0;
	for (int i=0; i<3; i++) fRec11[i] = 0;
	for (int i=0; i<3; i++) fRec10[i] = 0;
	for (int i=0; i<3; i++) fRec9[i] = 0;
	for (int i=0; i<3; i++) fRec8[i] = 0;
	for (int i=0; i<2; i++) fRec7[i] = 0;
}

void compute(int count, float *input0, float *input1, float *output0, float *output1)
{
	double 	fSlow0 = pow(10,(0.05 * fslider0));
	double 	fSlow1 = (0.5 * ((int(fcheckbox0))?2:fslider1));
	double 	fSlow2 = (1 - fSlow1);
	double 	fSlow3 = exp((fConst0 * (0 - (3.141592653589793 * fslider2))));
	double 	fSlow4 = faustpower<2>(fSlow3);
	double 	fSlow5 = (0 - (2 * fSlow3));
	double 	fSlow6 = fslider3;
	double 	fSlow7 = (fConst0 * faustpower<3>(fSlow6));
	double 	fSlow8 = fslider4;
	double 	fSlow9 = (6.283185307179586 * fSlow8);
	double 	fSlow10 = (0.5 * ((6.283185307179586 * max(fSlow8, fslider5)) - fSlow9));
	double 	fSlow11 = (fConst1 * fslider6);
	double 	fSlow12 = sin(fSlow11);
	double 	fSlow13 = cos(fSlow11);
	double 	fSlow14 = (0 - fSlow12);
	double 	fSlow15 = (fConst0 * faustpower<2>(fSlow6));
	double 	fSlow16 = (fConst0 * fSlow6);
	double 	fSlow17 = fslider7;
	double 	fSlow18 = (fConst0 * faustpower<4>(fSlow6));
	double 	fSlow19 = ((int(fcheckbox1))?(0 - fSlow1):fSlow1);
	for (int i=0; i<count; i++) {
		double fTemp0 = (double)input0[i];
		iVec0[0] = 1;
		fRec2[0] = ((fSlow12 * fRec3[1]) + (fSlow13 * fRec2[1]));
		fRec3[0] = ((1 + ((fSlow13 * fRec3[1]) + (fSlow14 * fRec2[1]))) - iVec0[1]);
		double fTemp1 = (fSlow9 + (fSlow10 * (1 - fRec2[0])));
		double fTemp2 = (cos((fSlow16 * fTemp1)) * fRec6[1]);
		fRec6[0] = (((fSlow0 * fTemp0) + (fSlow17 * fRec0[1])) - ((fSlow5 * fTemp2) + (fSlow4 * fRec6[2])));
		double fTemp3 = (cos((fSlow15 * fTemp1)) * fRec5[1]);
		fRec5[0] = ((fSlow5 * (fTemp2 - fTemp3)) + (fRec6[2] + (fSlow4 * (fRec6[0] - fRec5[2]))));
		double fTemp4 = (cos((fSlow7 * fTemp1)) * fRec4[1]);
		fRec4[0] = ((fSlow5 * (fTemp3 - fTemp4)) + (fRec5[2] + (fSlow4 * (fRec5[0] - fRec4[2]))));
		double fTemp5 = (cos((fSlow18 * fTemp1)) * fRec1[1]);
		fRec1[0] = ((fSlow5 * (fTemp4 - fTemp5)) + (fRec4[2] + (fSlow4 * (fRec4[0] - fRec1[2]))));
		fRec0[0] = ((fSlow4 * fRec1[0]) + ((fSlow5 * fTemp5) + fRec1[2]));
		output0[i] = (FAUSTFLOAT)((fSlow0 * (fTemp0 * fSlow2)) + (fRec0[0] * fSlow19));
		double fTemp6 = (double)input1[i];
		double fTemp7 = (fSlow9 + (fSlow10 * (1 - fRec3[0])));
		double fTemp8 = (cos((fSlow16 * fTemp7)) * fRec11[1]);
		fRec11[0] = (((fSlow0 * fTemp6) + (fSlow17 * fRec7[1])) - ((fSlow5 * fTemp8) + (fSlow4 * fRec11[2])));
		double fTemp9 = (cos((fSlow15 * fTemp7)) * fRec10[1]);
		fRec10[0] = ((fSlow5 * (fTemp8 - fTemp9)) + (fRec11[2] + (fSlow4 * (fRec11[0] - fRec10[2]))));
		double fTemp10 = (cos((fSlow7 * fTemp7)) * fRec9[1]);
		fRec9[0] = ((fSlow5 * (fTemp9 - fTemp10)) + (fRec10[2] + (fSlow4 * (fRec10[0] - fRec9[2]))));
		double fTemp11 = (cos((fSlow18 * fTemp7)) * fRec8[1]);
		fRec8[0] = ((fSlow5 * (fTemp10 - fTemp11)) + (fRec9[2] + (fSlow4 * (fRec9[0] - fRec8[2]))));
		fRec7[0] = ((fSlow4 * fRec8[0]) + ((fSlow5 * fTemp11) + fRec8[2]));
		output1[i] = (FAUSTFLOAT)((fSlow0 * (fTemp6 * fSlow2)) + (fRec7[0] * fSlow19));
		// post processing
		fRec7[1] = fRec7[0];
		fRec8[2] = fRec8[1]; fRec8[1] = fRec8[0];
		fRec9[2] = fRec9[1]; fRec9[1] = fRec9[0];
		fRec10[2] = fRec10[1]; fRec10[1] = fRec10[0];
		fRec11[2] = fRec11[1]; fRec11[1] = fRec11[0];
		fRec0[1] = fRec0[0];
		fRec1[2] = fRec1[1]; fRec1[1] = fRec1[0];
		fRec4[2] = fRec4[1]; fRec4[1] = fRec4[0];
		fRec5[2] = fRec5[1]; fRec5[1] = fRec5[0];
		fRec6[2] = fRec6[1]; fRec6[1] = fRec6[0];
		fRec3[1] = fRec3[0];
		fRec2[1] = fRec2[0];
		iVec0[1] = iVec0[0];
	}
}

static struct RegisterParams { RegisterParams(); } RegisterParams;
RegisterParams::RegisterParams()
{
	static const char *fcheckbox1_values[] = {"linear","invert",0};
	registerEnumVar("phaser.invert","","B","",fcheckbox1_values,&fcheckbox1, 0.0, 0.0, 1.0, 1.0);
	static const char *fcheckbox0_values[] = {"direct "," vibrato",0};
	registerEnumVar("phaser.VibratoMode","","B","",fcheckbox0_values,&fcheckbox0, 0.0, 0.0, 1.0, 1.0);
	registerVar("phaser.feedback gain","","S","",&fslider7, 0.0, 0.0, 1.0, 0.01);
	registerVar("phaser.Speed","","S","",&fslider6, 0.5, 0.0, 1e+01, 0.01);
	registerVar("phaser.MaxNotch1Freq","","S","",&fslider5, 8e+02, 2e+01, 1e+04, 1.0);
	registerVar("phaser.MinNotch1Freq","","S","",&fslider4, 1e+02, 2e+01, 5e+03, 1.0);
	registerVar("phaser.NotchFreq","","S","",&fslider3, 1.5, 1.1, 4.0, 0.01);
	registerVar("phaser.Notch width","","S","",&fslider2, 1e+03, 1e+01, 5e+03, 1.0);
	registerVar("phaser.depth","","S","",&fslider1, 1.0, 0.0, 1.0, 0.01);
	registerVar("phaser.level","","S","",&fslider0, 0.0, -6e+01, 1e+01, 0.1);
	registerInit("phaser", init);
}

} // end namespace phaser
