namespace phaser_mono {
// generated from file '../src/faust/phaser_mono.dsp'

int 	iVec0[2];
FAUSTFLOAT 	fslider0;
double 	fConst0;
double 	fConst1;
double 	fConst2;
double 	fConst3;
double 	fConst4;
FAUSTFLOAT 	fslider1;
double 	fRec2[2];
double 	fRec3[2];
double 	fConst5;
double 	fConst6;
FAUSTFLOAT 	fslider2;
double 	fRec6[3];
double 	fRec5[3];
double 	fRec4[3];
double 	fConst7;
double 	fRec1[3];
double 	fRec0[2];
int 	iConst8;
int	fSamplingFreq;

void init(int samplingFreq)
{
	fSamplingFreq = samplingFreq;
	for (int i=0; i<2; i++) iVec0[i] = 0;
	fConst0 = exp((0 - (3141.592653589793 / fSamplingFreq)));
	fConst1 = faustpower<2>(fConst0);
	fConst2 = (0 - (2 * fConst0));
	fConst3 = (8.0 / fSamplingFreq);
	fConst4 = (6.283185307179586 / fSamplingFreq);
	for (int i=0; i<2; i++) fRec2[i] = 0;
	for (int i=0; i<2; i++) fRec3[i] = 0;
	fConst5 = (4.0 / fSamplingFreq);
	fConst6 = (2.0 / fSamplingFreq);
	for (int i=0; i<3; i++) fRec6[i] = 0;
	for (int i=0; i<3; i++) fRec5[i] = 0;
	for (int i=0; i<3; i++) fRec4[i] = 0;
	fConst7 = (16.0 / fSamplingFreq);
	for (int i=0; i<3; i++) fRec1[i] = 0;
	for (int i=0; i<2; i++) fRec0[i] = 0;
	iConst8 = ((1)?-1:1);
}

void compute(int count, float *input0, float *output0)
{
	double 	fSlow0 = fslider0;
	double 	fSlow1 = (1 - (0.01 * fSlow0));
	double 	fSlow2 = (fConst4 * fslider1);
	double 	fSlow3 = sin(fSlow2);
	double 	fSlow4 = cos(fSlow2);
	double 	fSlow5 = (0 - fSlow3);
	double 	fSlow6 = (0.01 * (fSlow0 * pow(10,(0.05 * fslider2))));
	for (int i=0; i<count; i++) {
		iVec0[0] = 1;
		double fTemp0 = (double)input0[i];
		fRec2[0] = ((fSlow3 * fRec3[1]) + (fSlow4 * fRec2[1]));
		fRec3[0] = ((1 + ((fSlow4 * fRec3[1]) + (fSlow5 * fRec2[1]))) - iVec0[1]);
		double fTemp1 = (628.3185307179587 + (2199.1148575128555 * (1 - fRec2[0])));
		double fTemp2 = (cos((fConst6 * fTemp1)) * fRec6[1]);
		fRec6[0] = (((fSlow6 * fTemp0) + (0.5 * fRec0[1])) - ((fConst2 * fTemp2) + (fConst1 * fRec6[2])));
		double fTemp3 = (cos((fConst5 * fTemp1)) * fRec5[1]);
		fRec5[0] = ((fConst2 * (fTemp2 - fTemp3)) + (fRec6[2] + (fConst1 * (fRec6[0] - fRec5[2]))));
		double fTemp4 = (cos((fConst3 * fTemp1)) * fRec4[1]);
		fRec4[0] = ((fConst2 * (fTemp3 - fTemp4)) + (fRec5[2] + (fConst1 * (fRec5[0] - fRec4[2]))));
		double fTemp5 = (cos((fConst7 * fTemp1)) * fRec1[1]);
		fRec1[0] = ((fConst2 * (fTemp4 - fTemp5)) + (fRec4[2] + (fConst1 * (fRec4[0] - fRec1[2]))));
		fRec0[0] = ((fConst1 * fRec1[0]) + ((fConst2 * fTemp5) + fRec1[2]));
		output0[i] = (FAUSTFLOAT)((fSlow1 * fTemp0) + (fRec0[0] * iConst8));
		// post processing
		fRec0[1] = fRec0[0];
		fRec1[2] = fRec1[1]; fRec1[1] = fRec1[0];
		fRec4[2] = fRec4[1]; fRec4[1] = fRec4[0];
		fRec5[2] = fRec5[1]; fRec5[1] = fRec5[0];
		fRec6[2] = fRec6[1]; fRec6[1] = fRec6[0];
		fRec3[1] = fRec3[0];
		fRec2[1] = fRec2[0];
		iVec0[1] = iVec0[0];
	}
}

static struct RegisterParams { RegisterParams(); } RegisterParams;
RegisterParams::RegisterParams()
{
	registerVar("phaser_mono.level","","S","",&fslider2, 0.0, -6e+01, 1e+01, 0.1);
	registerVar("phaser_mono.Speed","","S","",&fslider1, 0.5, 0.0, 1e+01, 0.01);
	registerVar("phaser_mono.wet_dry","wet/dry","S","percentage of processed signal in output signal",&fslider0, 1e+02, 0.0, 1e+02, 1.0);
	registerInit("phaser_mono", init);
}

} // end namespace phaser_mono
