namespace stereodelay {
// generated from file '../src/faust/stereodelay.dsp'

volatile bool inited = false;
int 	IOTA;
float *fVec0;
int 	iVec1[2];
FAUSTFLOAT 	fslider0;
float 	fRec0[2];
FAUSTFLOAT 	fcheckbox0;
float 	fConst0;
FAUSTFLOAT 	fslider1;
float 	fRec1[2];
float 	fRec2[2];
float 	fConst1;
FAUSTFLOAT 	fslider2;
float *fVec2;
FAUSTFLOAT 	fslider3;
float 	fRec3[2];
FAUSTFLOAT 	fslider4;
int	fSamplingFreq;

void init(int samplingFreq)
{
	if (!fVec0) fVec0 = new float[262144];
	if (!fVec2) fVec2 = new float[262144];
	fSamplingFreq = samplingFreq;
	IOTA = 0;
	for (int i=0; i<262144; i++) fVec0[i] = 0;
	for (int i=0; i<2; i++) iVec1[i] = 0;
	for (int i=0; i<2; i++) fRec0[i] = 0;
	fConst0 = (6.283185307179586f / fSamplingFreq);
	for (int i=0; i<2; i++) fRec1[i] = 0;
	for (int i=0; i<2; i++) fRec2[i] = 0;
	fConst1 = (0.001f * fSamplingFreq);
	for (int i=0; i<262144; i++) fVec2[i] = 0;
	for (int i=0; i<2; i++) fRec3[i] = 0;
	inited = true;
}

void mem_free()
{
	inited = false;
	jack_sync();
	if (fVec0) { delete fVec0; fVec0 = 0; }
	if (fVec2) { delete fVec2; fVec2 = 0; }
}

inline bool is_inited()
{
    return inited;
}


void activate(bool start, int samplingFreq)
{
	if (start) {
		if (!is_inited()) {
			init(samplingFreq);
		}
	} else {
		if (is_inited()) {
			mem_free();
		}
	}
}

void compute(int count, float *input0, float *input1, float *output0, float *output1)
{
	float 	fSlow0 = (0.0010000000000000009f * powf(10,(0.05f * fslider0)));
	float 	fSlow1 = fcheckbox0;
	float 	fSlow2 = (fConst0 * fslider1);
	float 	fSlow3 = sinf(fSlow2);
	float 	fSlow4 = cosf(fSlow2);
	float 	fSlow5 = (0 - fSlow3);
	float 	fSlow6 = (fConst1 * fslider2);
	int 	iSlow7 = int(fSlow6);
	int 	iSlow8 = (1 + iSlow7);
	float 	fSlow9 = (iSlow8 - fSlow6);
	int 	iSlow10 = int((iSlow7 & 262143));
	float 	fSlow11 = (fSlow6 - iSlow7);
	int 	iSlow12 = int((int(iSlow8) & 262143));
	float 	fSlow13 = (0.0010000000000000009f * powf(10,(0.05f * fslider3)));
	float 	fSlow14 = (fConst1 * fslider4);
	int 	iSlow15 = int(fSlow14);
	int 	iSlow16 = (1 + iSlow15);
	float 	fSlow17 = (iSlow16 - fSlow14);
	int 	iSlow18 = int((iSlow15 & 262143));
	float 	fSlow19 = (fSlow14 - iSlow15);
	int 	iSlow20 = int((int(iSlow16) & 262143));
	for (int i=0; i<count; i++) {
		float fTemp0 = (float)input0[i];
		fVec0[IOTA&262143] = fTemp0;
		iVec1[0] = 1;
		fRec0[0] = ((0.999f * fRec0[1]) + fSlow0);
		fRec1[0] = ((fSlow3 * fRec2[1]) + (fSlow4 * fRec1[1]));
		fRec2[0] = ((1 + ((fSlow4 * fRec2[1]) + (fSlow5 * fRec1[1]))) - iVec1[1]);
		float fTemp1 = (fSlow1 * fRec1[0]);
		output0[i] = (FAUSTFLOAT)(fVec0[IOTA&262143] + ((fRec0[0] * (1 + fTemp1)) * ((fSlow9 * fVec0[(IOTA-iSlow10)&262143]) + (fSlow11 * fVec0[(IOTA-iSlow12)&262143]))));
		float fTemp2 = (float)input1[i];
		fVec2[IOTA&262143] = fTemp2;
		fRec3[0] = ((0.999f * fRec3[1]) + fSlow13);
		output1[i] = (FAUSTFLOAT)(fVec2[IOTA&262143] + ((fRec3[0] * (1 - fTemp1)) * ((fSlow17 * fVec2[(IOTA-iSlow18)&262143]) + (fSlow19 * fVec2[(IOTA-iSlow20)&262143]))));
		// post processing
		fRec3[1] = fRec3[0];
		fRec2[1] = fRec2[0];
		fRec1[1] = fRec1[0];
		fRec0[1] = fRec0[0];
		iVec1[1] = iVec1[0];
		IOTA = IOTA+1;
	}
}

static struct RegisterParams { RegisterParams(); } RegisterParams;
RegisterParams::RegisterParams()
{
	static const char *fcheckbox0_values[] = {"linear","pingpong",0};
	registerEnumVar("stereodelay.invert","","B","",fcheckbox0_values,&fcheckbox0, 0.0, 0.0, 1.0, 1.0);
	registerVar("stereodelay.r_delay","","S","",&fslider4, 0.0f, 0.0f, 5e+03f, 1e+01f);
	registerVar("stereodelay.r_gain","","S","",&fslider3, 0.0f, -2e+01f, 2e+01f, 0.1f);
	registerVar("stereodelay.l_delay","","S","",&fslider2, 0.0f, 0.0f, 5e+03f, 1e+01f);
	registerVar("stereodelay.LFO freq","","S","",&fslider1, 0.2f, 0.0f, 5.0f, 0.01f);
	registerVar("stereodelay.l_gain","","S","",&fslider0, 0.0f, -2e+01f, 2e+01f, 0.1f);
	registerInit("stereodelay", init);
}

} // end namespace stereodelay
