namespace tonestack_default {
// generated from file '../src/faust/tonestack_default.dsp'

FAUSTFLOAT&	fslider0 = get_alias("amp.tonestack.Treble");
FAUSTFLOAT&	fslider1 = get_alias("amp.tonestack.Middle");
double 	fConst0;
double 	fConst1;
double 	fConst2;
double 	fConst3;
double 	fConst4;
double 	fConst5;
FAUSTFLOAT&	fslider2 = get_alias("amp.tonestack.Bass");
double 	fVec0[3];
double 	fRec3[3];
double 	fRec2[3];
double 	fRec1[3];
double 	fRec0[3];
int	fSamplingFreq;

void init(int samplingFreq)
{
	fSamplingFreq = samplingFreq;
	fConst0 = (15079.644737231007 / fSamplingFreq);
	fConst1 = (1.4142135623730951 * sin(fConst0));
	fConst2 = cos(fConst0);
	fConst3 = (3769.9111843077517 / fSamplingFreq);
	fConst4 = (1.4142135623730951 * sin(fConst3));
	fConst5 = cos(fConst3);
	for (int i=0; i<3; i++) fVec0[i] = 0;
	for (int i=0; i<3; i++) fRec3[i] = 0;
	for (int i=0; i<3; i++) fRec2[i] = 0;
	for (int i=0; i<3; i++) fRec1[i] = 0;
	for (int i=0; i<3; i++) fRec0[i] = 0;
}

void compute(int count, float *input0, float *output0)
{
	double 	fSlow0 = (fslider1 - 0.5);
	double 	fSlow1 = (10 * fSlow0);
	double 	fSlow2 = pow(10,(0.025 * ((20 * (fslider0 - 0.5)) - fSlow1)));
	double 	fSlow3 = (fConst1 * sqrt(fSlow2));
	double 	fSlow4 = (fConst2 * (fSlow2 - 1));
	double 	fSlow5 = (1.0 / ((1 + (fSlow2 + fSlow3)) - fSlow4));
	double 	fSlow6 = (1 + fSlow2);
	double 	fSlow7 = (fSlow6 - (fSlow4 + fSlow3));
	double 	fSlow8 = (fConst2 * fSlow6);
	double 	fSlow9 = (2 * (fSlow2 - (1 + fSlow8)));
	double 	fSlow10 = (fSlow2 + fSlow4);
	double 	fSlow11 = (fSlow2 * (1 + (fSlow10 + fSlow3)));
	double 	fSlow12 = pow(10,(0.25 * fSlow0));
	double 	fSlow13 = sqrt(fSlow12);
	double 	fSlow14 = (fConst4 * fSlow13);
	double 	fSlow15 = (fSlow12 - 1);
	double 	fSlow16 = (fConst5 * fSlow15);
	double 	fSlow17 = (1.0 / ((1 + (fSlow12 + fSlow14)) - fSlow16));
	double 	fSlow18 = (1 + fSlow12);
	double 	fSlow19 = (fSlow18 - (fSlow16 + fSlow14));
	double 	fSlow20 = (fConst5 * fSlow18);
	double 	fSlow21 = (2 * (fSlow12 - (1 + fSlow20)));
	double 	fSlow22 = (fSlow12 + fSlow16);
	double 	fSlow23 = (fSlow12 * (1 + (fSlow22 + fSlow14)));
	double 	fSlow24 = (fConst1 * fSlow13);
	double 	fSlow25 = (fConst2 * fSlow15);
	double 	fSlow26 = (fSlow12 + fSlow25);
	double 	fSlow27 = (1.0 / (1 + (fSlow24 + fSlow26)));
	double 	fSlow28 = (fConst2 * fSlow18);
	double 	fSlow29 = (0 - (2 * ((fSlow12 + fSlow28) - 1)));
	double 	fSlow30 = ((1 + fSlow26) - fSlow24);
	double 	fSlow31 = ((1 + (fSlow12 + fSlow24)) - fSlow25);
	double 	fSlow32 = pow(10,(0.025 * ((20 * (exp((3.4 * (fslider2 - 1))) - 0.5)) - fSlow1)));
	double 	fSlow33 = (fConst4 * sqrt(fSlow32));
	double 	fSlow34 = (fConst5 * (fSlow32 - 1));
	double 	fSlow35 = (fSlow32 + fSlow34);
	double 	fSlow36 = (1.0 / (1 + (fSlow33 + fSlow35)));
	double 	fSlow37 = (1 + fSlow32);
	double 	fSlow38 = (fConst5 * fSlow37);
	double 	fSlow39 = (0 - (2 * ((fSlow32 + fSlow38) - 1)));
	double 	fSlow40 = ((1 + fSlow35) - fSlow33);
	double 	fSlow41 = ((1 + (fSlow32 + fSlow33)) - fSlow34);
	double 	fSlow42 = (2 * (fSlow32 - (1 + fSlow38)));
	double 	fSlow43 = (fSlow37 - (fSlow34 + fSlow33));
	double 	fSlow44 = (2 * (fSlow12 - (1 + fSlow28)));
	double 	fSlow45 = (fSlow18 - (fSlow25 + fSlow24));
	double 	fSlow46 = ((0 - (2 * fSlow12)) * ((fSlow12 + fSlow20) - 1));
	double 	fSlow47 = (fSlow12 * ((1 + fSlow22) - fSlow14));
	double 	fSlow48 = ((0 - (2 * fSlow2)) * ((fSlow2 + fSlow8) - 1));
	double 	fSlow49 = (fSlow2 * ((1 + fSlow10) - fSlow3));
	for (int i=0; i<count; i++) {
		double fTemp0 = (double)input0[i];
		fVec0[0] = fTemp0;
		fRec3[0] = (fSlow36 * ((0 - ((fSlow39 * fRec3[1]) + (fSlow40 * fRec3[2]))) + (fSlow32 * (((fSlow41 * fVec0[0]) + (fSlow42 * fVec0[1])) + (fSlow43 * fVec0[2])))));
		fRec2[0] = (fSlow27 * ((0 - ((fSlow29 * fRec2[1]) + (fSlow30 * fRec2[2]))) + (fSlow12 * (((fSlow31 * fRec3[0]) + (fSlow44 * fRec3[1])) + (fSlow45 * fRec3[2])))));
		fRec1[0] = (fSlow17 * ((0 - ((fSlow19 * fRec1[2]) + (fSlow21 * fRec1[1]))) + (((fSlow23 * fRec2[0]) + (fSlow46 * fRec2[1])) + (fSlow47 * fRec2[2]))));
		fRec0[0] = (fSlow5 * ((0 - ((fSlow7 * fRec0[2]) + (fSlow9 * fRec0[1]))) + (((fSlow11 * fRec1[0]) + (fSlow48 * fRec1[1])) + (fSlow49 * fRec1[2]))));
		output0[i] = (FAUSTFLOAT)fRec0[0];
		// post processing
		fRec0[2] = fRec0[1]; fRec0[1] = fRec0[0];
		fRec1[2] = fRec1[1]; fRec1[1] = fRec1[0];
		fRec2[2] = fRec2[1]; fRec2[1] = fRec2[0];
		fRec3[2] = fRec3[1]; fRec3[1] = fRec3[0];
		fVec0[2] = fVec0[1]; fVec0[1] = fVec0[0];
	}
}

static struct RegisterParams { RegisterParams(); } RegisterParams;
RegisterParams::RegisterParams()
{
	registerInit("amp.tonestack", init);
}

} // end namespace tonestack_default
