namespace tonestack_soldano {
// generated from file '../src/faust/tonestack_soldano.dsp'

double 	fConst0;
double 	fConst1;
FAUSTFLOAT&	fslider0 = get_alias("amp.tonestack.Middle");
FAUSTFLOAT&	fslider1 = get_alias("amp.tonestack.Bass");
FAUSTFLOAT&	fslider2 = get_alias("amp.tonestack.Treble");
double 	fConst2;
double 	fRec0[4];
int	fSamplingFreq;

void init(int samplingFreq)
{
	fSamplingFreq = samplingFreq;
	fConst0 = (2 * double(fSamplingFreq));
	fConst1 = faustpower<2>(fConst0);
	fConst2 = (3 * fConst0);
	for (int i=0; i<4; i++) fRec0[i] = 0;
}

void compute(int count, float *input0, float *output0)
{
	double 	fSlow0 = fslider0;
	double 	fSlow1 = exp((3.4 * (fslider1 - 1)));
	double 	fSlow2 = (2.5587500000000006e-07 * fSlow0);
	double 	fSlow3 = (((fSlow0 * (((1.0235000000000001e-05 * fSlow1) - 1.5537499999999997e-07) - fSlow2)) + (2.2033600000000005e-05 * fSlow1)) + 7.717400000000001e-07);
	double 	fSlow4 = (2.2090000000000005e-09 * fSlow1);
	double 	fSlow5 = ((1.3959000000000001e-09 * fSlow1) - (3.48975e-11 * fSlow0));
	double 	fSlow6 = (5.522500000000001e-11 + (fSlow4 + (fSlow0 * (fSlow5 - 2.0327500000000007e-11))));
	double 	fSlow7 = (fConst0 * fSlow6);
	double 	fSlow8 = (0.0005 * fSlow0);
	double 	fSlow9 = (0.020470000000000002 * fSlow1);
	double 	fSlow10 = (fConst0 * (0.0025092499999999998 + (fSlow8 + fSlow9)));
	double 	fSlow11 = (1.0 / ((fConst1 * (0 - (fSlow3 + fSlow7))) - (1 + fSlow10)));
	double 	fSlow12 = fslider2;
	double 	fSlow13 = ((((0.00011750000000000001 * fSlow12) + fSlow8) + fSlow9) + 0.00051175);
	double 	fSlow14 = (fConst0 * (0 - fSlow13));
	double 	fSlow15 = ((((2.2090000000000003e-07 * fSlow12) + (fSlow0 * (3.146250000000001e-07 - fSlow2))) + (fSlow1 * (3.2336000000000007e-06 + (1.0235000000000001e-05 * fSlow0)))) + 8.084000000000001e-08);
	double 	fSlow16 = ((fSlow0 * (3.48975e-11 + fSlow5)) + (fSlow12 * ((5.522500000000001e-11 - (5.522500000000001e-11 * fSlow0)) + fSlow4)));
	double 	fSlow17 = (fConst0 * fSlow16);
	double 	fSlow18 = (fSlow14 + (fConst1 * (0 - (fSlow15 + fSlow17))));
	double 	fSlow19 = (fConst2 * fSlow6);
	double 	fSlow20 = ((fConst1 * (fSlow3 + fSlow19)) - (3 + fSlow10));
	double 	fSlow21 = ((fSlow10 + (fConst1 * (fSlow3 - fSlow19))) - 3);
	double 	fSlow22 = ((fSlow10 + (fConst1 * (fSlow7 - fSlow3))) - 1);
	double 	fSlow23 = (fConst2 * fSlow16);
	double 	fSlow24 = (fSlow14 + (fConst1 * (fSlow15 + fSlow23)));
	double 	fSlow25 = (fConst0 * fSlow13);
	double 	fSlow26 = (fSlow25 + (fConst1 * (fSlow15 - fSlow23)));
	double 	fSlow27 = (fSlow25 + (fConst1 * (fSlow17 - fSlow15)));
	for (int i=0; i<count; i++) {
		fRec0[0] = ((double)input0[i] - (fSlow11 * (((fSlow20 * fRec0[1]) + (fSlow21 * fRec0[2])) + (fSlow22 * fRec0[3]))));
		output0[i] = (FAUSTFLOAT)(fSlow11 * ((((fSlow18 * fRec0[0]) + (fSlow24 * fRec0[1])) + (fSlow26 * fRec0[2])) + (fSlow27 * fRec0[3])));
		// post processing
		for (int i=3; i>0; i--) fRec0[i] = fRec0[i-1];
	}
}

static struct RegisterParams { RegisterParams(); } RegisterParams;
RegisterParams::RegisterParams()
{
	registerInit("amp.tonestack", init);
}

} // end namespace tonestack_soldano
