namespace tonestack_twin {
// generated from file '../src/faust/tonestack_twin.dsp'

double 	fConst0;
double 	fConst1;
FAUSTFLOAT&	fslider0 = get_alias("amp.tonestack.Middle");
FAUSTFLOAT&	fslider1 = get_alias("amp.tonestack.Bass");
FAUSTFLOAT&	fslider2 = get_alias("amp.tonestack.Treble");
double 	fConst2;
double 	fRec0[4];
int	fSamplingFreq;

void init(int samplingFreq)
{
	fSamplingFreq = samplingFreq;
	fConst0 = (2 * double(fSamplingFreq));
	fConst1 = faustpower<2>(fConst0);
	fConst2 = (3 * fConst0);
	for (int i=0; i<4; i++) fRec0[i] = 0;
}

void compute(int count, float *input0, float *output0)
{
	double 	fSlow0 = fslider0;
	double 	fSlow1 = exp((3.4 * (fslider1 - 1)));
	double 	fSlow2 = (4.7056400000000006e-07 * fSlow0);
	double 	fSlow3 = (((fSlow0 * (((1.1764100000000001e-05 * fSlow1) - 4.215336e-06) - fSlow2)) + (0.00011869100000000002 * fSlow1)) + 5.188640000000001e-06);
	double 	fSlow4 = (3.525e-09 * fSlow1);
	double 	fSlow5 = ((4.935e-10 * fSlow1) - (1.974e-11 * fSlow0));
	double 	fSlow6 = (1.41e-10 + (fSlow4 + (fSlow0 * (fSlow5 - 1.2126e-10))));
	double 	fSlow7 = (fConst0 * fSlow6);
	double 	fSlow8 = (0.00047000000000000004 * fSlow0);
	double 	fSlow9 = (0.02503 * fSlow1);
	double 	fSlow10 = (fConst0 * (0.0157312 + (fSlow8 + fSlow9)));
	double 	fSlow11 = (1.0 / ((fConst1 * (0 - (fSlow3 + fSlow7))) - (1 + fSlow10)));
	double 	fSlow12 = fslider2;
	double 	fSlow13 = ((((3e-05 * fSlow12) + fSlow8) + fSlow9) + 0.0010012);
	double 	fSlow14 = (fConst0 * (0 - fSlow13));
	double 	fSlow15 = ((((4.410000000000001e-07 * fSlow12) + (fSlow0 * (4.846640000000001e-07 - fSlow2))) + (fSlow1 * (1.1910000000000001e-06 + (1.1764100000000001e-05 * fSlow0)))) + 4.764000000000001e-08);
	double 	fSlow16 = ((fSlow0 * (1.974e-11 + fSlow5)) + (fSlow12 * ((1.41e-10 - (1.41e-10 * fSlow0)) + fSlow4)));
	double 	fSlow17 = (fConst0 * fSlow16);
	double 	fSlow18 = (fSlow14 + (fConst1 * (0 - (fSlow15 + fSlow17))));
	double 	fSlow19 = (fConst2 * fSlow6);
	double 	fSlow20 = ((fConst1 * (fSlow3 + fSlow19)) - (3 + fSlow10));
	double 	fSlow21 = ((fSlow10 + (fConst1 * (fSlow3 - fSlow19))) - 3);
	double 	fSlow22 = ((fSlow10 + (fConst1 * (fSlow7 - fSlow3))) - 1);
	double 	fSlow23 = (fConst2 * fSlow16);
	double 	fSlow24 = (fSlow14 + (fConst1 * (fSlow15 + fSlow23)));
	double 	fSlow25 = (fConst0 * fSlow13);
	double 	fSlow26 = (fSlow25 + (fConst1 * (fSlow15 - fSlow23)));
	double 	fSlow27 = (fSlow25 + (fConst1 * (fSlow17 - fSlow15)));
	for (int i=0; i<count; i++) {
		fRec0[0] = ((double)input0[i] - (fSlow11 * (((fSlow20 * fRec0[1]) + (fSlow21 * fRec0[2])) + (fSlow22 * fRec0[3]))));
		output0[i] = (FAUSTFLOAT)(fSlow11 * ((((fSlow18 * fRec0[0]) + (fSlow24 * fRec0[1])) + (fSlow26 * fRec0[2])) + (fSlow27 * fRec0[3])));
		// post processing
		for (int i=3; i>0; i--) fRec0[i] = fRec0[i-1];
	}
}

static struct RegisterParams { RegisterParams(); } RegisterParams;
RegisterParams::RegisterParams()
{
	registerInit("amp.tonestack", init);
}

} // end namespace tonestack_twin
