namespace tremolo {
// generated from file '../src/faust/tremolo.dsp'

int 	iVec0[2];
FAUSTFLOAT 	fslider0;
double 	fConst0;
FAUSTFLOAT 	fslider1;
FAUSTFLOAT 	fcheckbox0;
double 	fConst1;
FAUSTFLOAT 	fslider2;
double 	fRec3[2];
double 	fRec2[2];
double 	fRec1[2];
double 	fConst2;
int 	iRec5[2];
int 	iRec4[2];
double 	fRec0[2];
int	fSamplingFreq;

void init(int samplingFreq)
{
	fSamplingFreq = samplingFreq;
	for (int i=0; i<2; i++) iVec0[i] = 0;
	fConst0 = (1.0 / fSamplingFreq);
	fConst1 = (6.283185307179586 / fSamplingFreq);
	for (int i=0; i<2; i++) fRec3[i] = 0;
	for (int i=0; i<2; i++) fRec2[i] = 0;
	for (int i=0; i<2; i++) fRec1[i] = 0;
	fConst2 = (0.5 * fSamplingFreq);
	for (int i=0; i<2; i++) iRec5[i] = 0;
	for (int i=0; i<2; i++) iRec4[i] = 0;
	for (int i=0; i<2; i++) fRec0[i] = 0;
}

void compute(int count, float *input0, float *output0)
{
	double 	fSlow0 = fslider0;
	double 	fSlow1 = (1 - (0.01 * fSlow0));
	double 	fSlow2 = (27.0 * fSlow0);
	double 	fSlow3 = fslider1;
	int 	iSlow4 = int(fcheckbox0);
	double 	fSlow5 = fslider2;
	double 	fSlow6 = (fConst1 * fSlow5);
	int 	iSlow7 = int((fConst2 / double(fSlow5)));
	double 	fSlow8 = (1.0 / iSlow7);
	for (int i=0; i<count; i++) {
		iVec0[0] = 1;
		double fTemp0 = (fRec0[1] * (1 - (fConst0 / (fConst0 + (0.06 * exp((0 - (2.4849066497880004 * fRec0[1]))))))));
		fRec3[0] = (fRec3[1] + (fSlow6 * (0 - fRec1[1])));
		fRec2[0] = ((1 + (fRec2[1] + (fSlow6 * fRec3[0]))) - iVec0[1]);
		fRec1[0] = fRec2[0];
		iRec5[0] = ((int((iRec5[1] > 0)))?((2 * (iRec4[1] < iSlow7)) - 1):(1 - (2 * (iRec4[1] > 0))));
		iRec4[0] = (iRec5[0] + iRec4[1]);
		fRec0[0] = (fTemp0 + (fConst0 * (pow((1 + (fSlow3 * (((iSlow4)?max(0, (0.5 * (1 + fRec1[0]))):(fSlow8 * iRec4[0])) - 1))),1.9) / (fConst0 + (0.06 * exp((0 - (2.4849066497880004 * fTemp0))))))));
		output0[i] = (FAUSTFLOAT)((double)input0[i] * (fSlow1 + (fSlow2 / (2700 + exp((13.815510557964274 / log((2.718281828459045 + (8.551967507929417 * fRec0[0])))))))));
		// post processing
		fRec0[1] = fRec0[0];
		iRec4[1] = iRec4[0];
		iRec5[1] = iRec5[0];
		fRec1[1] = fRec1[0];
		fRec2[1] = fRec2[0];
		fRec3[1] = fRec3[0];
		iVec0[1] = iVec0[0];
	}
}

static struct RegisterParams { RegisterParams(); } RegisterParams;
RegisterParams::RegisterParams()
{
	registerVar("tremolo.wet_dry","wet/dry","S","percentage of processed signal in output signal",&fslider0, 1e+02, 0.0, 1e+02, 1.0);
	static const char *fcheckbox0_values[] = {"triangle","sine",0};
	registerEnumVar("tremolo.SINE","","B","",fcheckbox0_values,&fcheckbox0, 0.0, 0.0, 1.0, 1.0);
	registerVar("tremolo.depth","","S","",&fslider1, 0.5, 0.0, 1.0, 0.01);
	registerVar("tremolo.freq","","S","",&fslider2, 5.0, 0.1, 5e+01, 0.1);
	registerInit("tremolo", init);
}

} // end namespace tremolo
